Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationCenter.cpp	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationCenter.cpp	(revision 93342)
@@ -763,4 +763,5 @@
     m_iAnimatedValue = iValue;
     adjustGeometry();
+    emit sigAnimationStep();
 }
 
@@ -799,5 +800,5 @@
     /* We do include open-button mask only if center is opened or animated to be: */
     QRegion region;
-    if (!m_iAnimatedValue)
+    if (!animatedValue())
         region += QRect(m_pButtonOpen->mapToParent(QPoint(0, 0)), m_pButtonOpen->size());
     setMask(region);
Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationCenter.h	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationCenter.h	(revision 93342)
@@ -55,4 +55,6 @@
     /** Requests sliding state-machine to close overlay. */
     void sigClose();
+    /** Notifies listeners about animation step. */
+    void sigAnimationStep();
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 93342)
@@ -247,4 +247,9 @@
 {
     return frameBuffer() ? (double)(frameBuffer()->width()) / frameBuffer()->height() : 0;
+}
+
+void UIMachineView::updateView()
+{
+    viewport()->update();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 93342)
@@ -102,4 +102,7 @@
     double aspectRatio() const;
 
+    /** Updates machine-view's viewport.
+      * @remarks Used to update in case of notification-center animation. */
+    void updateView();
     /** Updates console's display viewport.
       * @remarks Used to update 3D-service overlay viewport as well. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 93342)
@@ -178,4 +178,24 @@
     /* Update window-title: */
     updateAppearanceOf(UIVisualElement_WindowTitle);
+}
+
+void UIMachineWindow::sltHandleNotificationCenterAnimationStep()
+{
+    /* For certain machine states: */
+    const KMachineState enmState = uisession()->machineState();
+    switch (enmState)
+    {
+        /* Like those related to paused VM: */
+        case KMachineState_Paused:
+        case KMachineState_TeleportingPausedVM:
+        {
+            /* Update view's viewport, cause we have pause screenshot
+             * distorted with animation artifacts. */
+            machineView()->updateView();
+            break;
+        }
+        default:
+            break;
+    }
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 93342)
@@ -125,4 +125,7 @@
     virtual void sltMachineStateChanged();
 
+    /** Handles notification-center animation steps. */
+    void sltHandleNotificationCenterAnimationStep();
+
 protected:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 93342)
@@ -222,5 +222,10 @@
 {
     if (gpNotificationCenter && (m_uScreenId == 0))
+    {
         gpNotificationCenter->setParent(centralWidget());
+        disconnect(gpNotificationCenter, &UINotificationCenter::sigAnimationStep, 0, 0);
+        connect(gpNotificationCenter, &UINotificationCenter::sigAnimationStep,
+                this, &UIMachineWindowFullscreen::sltHandleNotificationCenterAnimationStep);
+    }
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 93342)
@@ -326,5 +326,10 @@
 {
     if (gpNotificationCenter && (m_uScreenId == 0))
+    {
         gpNotificationCenter->setParent(centralWidget());
+        disconnect(gpNotificationCenter, &UINotificationCenter::sigAnimationStep, 0, 0);
+        connect(gpNotificationCenter, &UINotificationCenter::sigAnimationStep,
+                this, &UIMachineWindowNormal::sltHandleNotificationCenterAnimationStep);
+    }
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 93341)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 93342)
@@ -62,5 +62,10 @@
 {
     if (gpNotificationCenter && (m_uScreenId == 0))
+    {
         gpNotificationCenter->setParent(centralWidget());
+        disconnect(gpNotificationCenter, &UINotificationCenter::sigAnimationStep, 0, 0);
+        connect(gpNotificationCenter, &UINotificationCenter::sigAnimationStep,
+                this, &UIMachineWindowScale::sltHandleNotificationCenterAnimationStep);
+    }
 }
 