Index: trunk/src/VBox/Additions/x11/VBoxClient/display-drm.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-drm.cpp	(revision 93379)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-drm.cpp	(revision 93380)
@@ -703,5 +703,5 @@
  *
  * @return  IPRT status code.
- * @param   pClient     Client connection information to add to the list.
+ * @param   pClientNode     Client connection information to add to the list.
  */
 static int vbDrmIpcClientsListAdd(PVBOX_DRMIPC_CLIENT_CONNECTION_LIST_NODE pClientNode)
@@ -733,5 +733,5 @@
  *
  * @return  IPRT status code.
- * @param   pClient     Client connection information to remove from the list.
+ * @param   pClientNode     Client connection information to remove from the list.
  */
 static int vbDrmIpcClientsListRemove(PVBOX_DRMIPC_CLIENT_CONNECTION_LIST_NODE pClientNode)
Index: trunk/src/VBox/Additions/x11/VBoxClient/display-helper-generic.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-helper-generic.cpp	(revision 93379)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-helper-generic.cpp	(revision 93380)
@@ -69,5 +69,5 @@
  * @return  TRUE if first name should go first in a list, FALSE otherwise.
  * @param   pszName1    First monitor name.
- * @param   pszName1    Second monitor name.
+ * @param   pszName2    Second monitor name.
  */
 static bool vbcl_hlp_generic_order_names(char *pszName1, char *pszName2)
Index: trunk/src/VBox/Additions/x11/VBoxClient/display-helper-gnome3.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-helper-gnome3.cpp	(revision 93379)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-helper-gnome3.cpp	(revision 93380)
@@ -141,5 +141,5 @@
  *
  * @return  True if message signature matches to given one.
- * @param   iter        D-bus message to check.
+ * @param   message     D-bus message to check.
  * @param   signature   Expected message signature.
  */
Index: trunk/src/VBox/Additions/x11/VBoxClient/display-helper.h
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-helper.h	(revision 93379)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-helper.h	(revision 93380)
@@ -112,5 +112,4 @@
  * Subscribe to display offset change notifications emitted by Generic Desktop Environment helper.
  *
- * @returns IPRT status code.
  * @param   pfnCb   A pointer to callback function which will be triggered when event arrives.
  */
@@ -119,6 +118,4 @@
 /**
  * Unsubscribe from display offset change notifications emitted by Generic Desktop Environment helper.
- *
- * @returns IPRT status code.
  */
 RTDECL(void) vbcl_hlp_generic_unsubscribe_display_offset_changed(void);
Index: trunk/src/VBox/Additions/x11/VBoxClient/display-ipc.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-ipc.cpp	(revision 93379)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-ipc.cpp	(revision 93380)
@@ -69,5 +69,5 @@
  * @param   hClientSession      IPC session handle obtained from RTLocalIpcSessionXXX().
  * @param   cTxListCapacity     Maximum number of messages which can be queued for TX for this IPC session.
- * @param   pfnCb               IPC RX callback function pointer.
+ * @param   pfnRxCb             IPC RX callback function pointer.
  */
 RTDECL(int) vbDrmIpcClientInit(PVBOX_DRMIPC_CLIENT pClient, RTTHREAD hThread, RTLOCALIPCSESSION hClientSession,
Index: trunk/src/VBox/Additions/x11/VBoxClient/display-svga-session.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-svga-session.cpp	(revision 93379)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-svga-session.cpp	(revision 93380)
@@ -88,5 +88,5 @@
  * @returns IPRT status code.
  * @param   cDisplays   Number of displays which have changed offset.
- * @param   pDisplays   Display data.
+ * @param   paDisplays  Display data.
  */
 static DECLCALLBACK(int) vbclSVGASessionDisplayOffsetChanged(uint32_t cOffsets, RTPOINT *paOffsets)