Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 93559)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 93560)
@@ -20558,4 +20558,22 @@
         <desc>AMD PCnet-ISA/NE2100 network card (Am79C960).</desc>
     </const>
+    <const name="NE2000"                value="8">
+        <desc>Novell NE2000 network card (NE2000).</desc>
+    </const>
+    <const name="NE1000"                value="9">
+        <desc>Novell NE1000 network card (NE1000).</desc>
+    </const>
+    <const name="WD8013"                value="10">
+        <desc>WD/SMC EtherCard Plus 16 network card (WD8013EBT).</desc>
+    </const>
+    <const name="WD8003"                value="11">
+        <desc>WD/SMC EtherCard Plus network card (WD8003E).</desc>
+    </const>
+    <const name="3C503"                 value="12">
+        <desc>3Com EtherLink II network card (3C503).</desc>
+    </const>
+    <const name="3C501"                 value="13">
+        <desc>3Com EtherLink network card (3C501/3C500).</desc>
+    </const>
   </enum>
 
Index: trunk/src/VBox/Main/src-client/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 93559)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 93560)
@@ -1567,4 +1567,12 @@
             return "virtio-net";
 #endif
+        case NetworkAdapterType_NE1000:
+        case NetworkAdapterType_NE2000:
+        case NetworkAdapterType_WD8003:
+        case NetworkAdapterType_WD8013:
+        case NetworkAdapterType_3C503:
+            return "dp8390";
+        case NetworkAdapterType_3C501:
+            return "3c501";
         default:
             AssertFailed();
Index: trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp	(revision 93559)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp	(revision 93560)
@@ -2630,4 +2630,9 @@
         InsertConfigNode(pDevices, "virtio-net", &pDevVirtioNet);
 #endif /* VBOX_WITH_VIRTIO */
+        PCFGMNODE pDevDP8390 = NULL;         /* DP8390-type devices */
+        InsertConfigNode(pDevices, "dp8390", &pDevDP8390);
+        PCFGMNODE pDev3C501 = NULL;          /* EtherLink-type devices */
+        InsertConfigNode(pDevices, "3c501",  &pDev3C501);
+
         std::list<BootNic> llBootNics;
         for (ULONG uInstance = 0; uInstance < maxNetworkAdapters; ++uInstance)
@@ -2667,4 +2672,14 @@
                     break;
 #endif /* VBOX_WITH_VIRTIO */
+                case NetworkAdapterType_NE1000:
+                case NetworkAdapterType_NE2000:
+                case NetworkAdapterType_WD8003:
+                case NetworkAdapterType_WD8013:
+                case NetworkAdapterType_3C503:
+                    pDev = pDevDP8390;
+                    break;
+                case NetworkAdapterType_3C501:
+                    pDev = pDev3C501;
+                    break;
                 default:
                     AssertMsgFailed(("Invalid network adapter type '%d' for slot '%d'", adapterType, uInstance));
@@ -2753,4 +2768,21 @@
                     break;
                 case NetworkAdapterType_Virtio:
+                    break;
+                case NetworkAdapterType_NE1000:
+                    InsertConfigString(pCfg, "DeviceType", "NE1000");
+                    break;
+                case NetworkAdapterType_NE2000:
+                    InsertConfigString(pCfg, "DeviceType", "NE2000");
+                    break;
+                case NetworkAdapterType_WD8003:
+                    InsertConfigString(pCfg, "DeviceType", "WD8003");
+                    break;
+                case NetworkAdapterType_WD8013:
+                    InsertConfigString(pCfg, "DeviceType", "WD8013");
+                    break;
+                case NetworkAdapterType_3C503:
+                    InsertConfigString(pCfg, "DeviceType", "3C503");
+                    break;
+                case NetworkAdapterType_3C501:
                     break;
                 case NetworkAdapterType_Null:      AssertFailedBreak(); /* (compiler warnings) */
Index: trunk/src/VBox/Main/src-server/NetworkAdapterImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/NetworkAdapterImpl.cpp	(revision 93559)
+++ trunk/src/VBox/Main/src-server/NetworkAdapterImpl.cpp	(revision 93560)
@@ -246,4 +246,10 @@
         case NetworkAdapterType_Virtio:
 #endif
+        case NetworkAdapterType_NE1000:
+        case NetworkAdapterType_NE2000:
+        case NetworkAdapterType_WD8003:
+        case NetworkAdapterType_WD8013:
+        case NetworkAdapterType_3C503:
+        case NetworkAdapterType_3C501:
             break;
         default:
Index: trunk/src/VBox/Main/xml/Settings.cpp
===================================================================
--- trunk/src/VBox/Main/xml/Settings.cpp	(revision 93559)
+++ trunk/src/VBox/Main/xml/Settings.cpp	(revision 93560)
@@ -4113,4 +4113,16 @@
             else if (strTemp == "virtio")
                 nic.type = NetworkAdapterType_Virtio;
+            else if (strTemp == "NE1000")
+                nic.type = NetworkAdapterType_NE1000;
+            else if (strTemp == "NE2000")
+                nic.type = NetworkAdapterType_NE2000;
+            else if (strTemp == "WD8003")
+                nic.type = NetworkAdapterType_WD8003;
+            else if (strTemp == "WD8013")
+                nic.type = NetworkAdapterType_WD8013;
+            else if (strTemp == "3C503")
+                nic.type = NetworkAdapterType_3C503;
+            else if (strTemp == "3C501")
+                nic.type = NetworkAdapterType_3C501;
             else
                 throw ConfigFileError(this, pelmAdapter, N_("Invalid value '%s' in Adapter/@type attribute"), strTemp.c_str());
@@ -6839,4 +6851,10 @@
                         case NetworkAdapterType_I82545EM:   pcszType = "82545EM"; break;
                         case NetworkAdapterType_Virtio:     pcszType = "virtio"; break;
+                        case NetworkAdapterType_NE1000:     pcszType = "NE1000"; break;
+                        case NetworkAdapterType_NE2000:     pcszType = "NE2000"; break;
+                        case NetworkAdapterType_WD8003:     pcszType = "WD8003"; break;
+                        case NetworkAdapterType_WD8013:     pcszType = "WD8013"; break;
+                        case NetworkAdapterType_3C503:      pcszType = "3C503"; break;
+                        case NetworkAdapterType_3C501:      pcszType = "3C501"; break;
                         default: /*case NetworkAdapterType_Am79C970A:*/  pcszType = "Am79C970A"; break;
                     }